/* This file was generated by SableCC (http://www.sablecc.org/). */

package org.sablecc.sablecc.node;

import java.util.LinkedList;
import java.util.List;

import de.hhu.stups.sablecc.patch.PositionedNode;

public abstract class Node extends PositionedNode implements Switchable, Cloneable
{
    private Node parent;

    protected Node()
    {}

    // clone intentionally does not keep parent!
    // The new copied node is not a child of the original parent anymore.
    @Override
    public abstract Node clone();

    public Node parent()
    {
        return this.parent;
    }

    void parent(Node parent)
    {
        this.parent = parent;
    }

    abstract void removeChild(Node child);
    abstract void replaceChild(Node oldChild, Node newChild);

    public void replaceBy(Node node)
    {
        this.parent.replaceChild(this, node);
    }

    protected static String toString(Node node)
    {
        if(node != null)
        {
            return node.toString();
        }

        return "";
    }

    protected static String toString(List<?> list)
    {
        StringBuilder s = new StringBuilder();

        for(Object o : list)
        {
            s.append(o);
        }

        return s.toString();
    }

    @SuppressWarnings("unchecked")
    protected static <T extends Node> T cloneNode(T node)
    {
        if(node != null)
        {
            return (T) node.clone();
        }

        return null;
    }

    @SuppressWarnings("unchecked")
    protected static <T extends Node> List<T> cloneList(List<T> list)
    {
        List<T> clone = new LinkedList<T>();

        for(T n : list)
        {
            clone.add((T) n.clone());
        }

        return clone;
    }
}
